//*****************************************************************************
// t@C	   DigitalPower.c
// Ώۃ}CR    TI C2000
// t@Ce    fW^d(PWMAADCACLA)
//             yoshikiyo
//*****************************************************************************
//=============================================================================
//include
//=============================================================================
#include	"DSP28x_Project.h"
#include 	"SFO_V6.h"
#include	"MainCVCC.h"
#include    "c.h"
#include	"DigitalPower.h"
#include	"SevenSeg.h"

// IQmathLib
#define		GLOBAL_Q 22 // range = +-512
#include	"IQmathLib.h"

// W֐
#include	<string.h>
#include	<stdint.h>
#include 	<stdio.h>
#include 	<stdlib.h>

//=============================================================================
//V{`
//=============================================================================

//=============================================================================
// Functions that will be run from RAM need to be assigned to
// a different section.  This section will then be mapped using
// the linker cmd file.
//=============================================================================

//=============================================================================
//t@C֐vg^Cv錾
//=============================================================================
//======================================
//interrupt
//======================================

//=============================================================================
//t@Cϐ̐錾
//=============================================================================
float VoltageSet = 0;
float CurrentSet = 0;

//PWMLu[Vp
int MEP_ScaleFactor = 0;
volatile struct EPWM_REGS *ePWM[PWM_CH] =
{&EPwm1Regs, &EPwm1Regs, &EPwm2Regs, &EPwm3Regs, &EPwm4Regs};

//======================================
//CLA֌W
//======================================
extern interrupt void Cla1Task1(void);
extern interrupt void Cla1Task2(void);
extern interrupt void Cla1Task3(void);
extern interrupt void Cla1Task4(void);
extern interrupt void Cla1Task5(void);
extern interrupt void Cla1Task6(void);
extern interrupt void Cla1Task7(void);
extern interrupt void Cla1Task8(void);

extern Uint16 Cla1Prog_Start;
extern Uint16 Cla1funcsLoadStart;
extern Uint16 Cla1funcsRunStart;
extern Uint16 Cla1funcsLoadSize;

//CPU to CLA RAM
#pragma DATA_SECTION(CPUtoCLARAM, "CpuToCla1MsgRAM");
CPUCLARAM CPUtoCLARAM = {0.0F,0.0F,0.0F,0.0F};
#pragma DATA_SECTION(CLAtoCPURAM, "Cla1ToCpuMsgRAM");
CLACPURAM CLAtoCPURAM = {0.0F,0.0F,0.0F,0.0F,0};

#pragma DATA_SECTION(ulCycleCount,"Cla1ToCpuMsgRAM");
long ulCycleCount;	//CLAxJE^

//*****************************************************************************
// fW^d̏
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void InitDigitalPower(void){
	InitCLA();				//CLȀ
	InitEPwm1(Pwm1PRD);		//PWM1̏
	InitEPwm6();			//CLAxp^C}[Ƃėp
	InitADC2();				//ADC

	SwOUT(ON);
	SwVoltageSet(0,0);
}

//*****************************************************************************
// fW^dvZX
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void DigitalPowerProcess(void){
	//XV
	if(Timer.LCDCnt >= 300){
		//7ZO\XV
		Timer.LCDCnt = Reset;
		MeasV_Sum = MeasV_Sum / 300;
		MeasA_Sum = MeasA_Sum / 300;
		SegOut((MeasV_Sum*0.0805861),MeasA_Sum*0.201465201);
		MeasV_Sum = 0;
		MeasA_Sum = 0;
	}

	//ddϏ
	VoltageSet = AdcResult.ADCRESULT2*0.00513;
	CurrentSet = AdcResult.ADCRESULT1*0.00125;
	if(VoltageSet >= 20.0){
		VoltageSet = 20.0;
	}
	if(CurrentSet >= 5.0){
		CurrentSet = 5.0;
	}
	SwVoltageSet(VoltageSet,CurrentSet);

	//CVCC\
	if(!CLAtoCPURAM.CVCC_FLAG){
		FullColorLed_Out(GREEN);
	}
	else{
		FullColorLed_Out(RED);
	}
}

//*****************************************************************************
// PWM1̏(\)
//  PWM(60MHz/PWM=Period)
// ߂l Ȃ
//*****************************************************************************
void InitEPwm1(long Period) {
	EALLOW;

	//Stop PWM Timer PWMWX^ݒ莞NbNK~
	SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 0;

	//GPIOPWMo͂֐ݒ
	GpioCtrlRegs.GPAMUX1.bit.GPIO0 = 1;
	GpioCtrlRegs.GPAMUX1.bit.GPIO1 = 1;

	//Time-Base(TB) Module̐ݒ
	EPwm1Regs.TBCTL.bit.PRDLD = TB_IMMEDIATE;	//ݒll𑦔f
	EPwm1Regs.TBPRD = Period - 1;				//PWM̐ݒ
	EPwm1Regs.TBPHS.all = 0;					//ʑ̐ݒ Master0
	EPwm1Regs.TBCTR = 0;						//JE^l̃NA

	EPwm1Regs.TBCTL.bit.CTRMODE = TB_COUNT_UP;	//^C}JEgAbv
	EPwm1Regs.TBCTL.bit.PHSEN = TB_DISABLE;		//^C}Ȃ(EPwm1Ƃđ̃^C}𓯊邽)
	EPwm1Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO;	//used to sync EPWM(n+1) "down-stream"
	EPwm1Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;
	EPwm1Regs.TBCTL.bit.CLKDIV = TB_DIV1;

	//Counter Compare (CC) Module̐ݒ@f[eB̐ݒ
	EPwm1Regs.CMPA.all = _IQtoIQ16( _IQmpyI32(_IQ(DutyCycl),(long)Period));		//CMPAfB[eB̐ݒ	l0
	EPwm1Regs.CMPB = 150;			//CMPBfB[eB̐ݒ	10%Œ
	EPwm1Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;	//CMPA@VhEWX^Lɂ
	EPwm1Regs.CMPCTL.bit.LOADAMODE = CC_SHADOW;	//CMPA@VhEWX^Lɂ

	//Action Qualifier(AQ) Module̐ݒ
	EPwm1Regs.AQCTLA.bit.ZRO = AQ_SET;
	EPwm1Regs.AQCTLA.bit.CAU = AQ_CLEAR;

	//Dead Band Generator(DB) Module̐ݒ
	EPwm1Regs.DBCTL.bit.OUT_MODE = DB_DISABLE;	//fbgohRg[
	EPwm1Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC;	//Active Hi Complimentary
	EPwm1Regs.DBRED = 2;						//dummy value for now
	EPwm1Regs.DBFED = 0;						//dummy value for now

	//HRPWM Module̐ݒ
	EPwm1Regs.HRCNFG.bit.SWAPAB = 0;	//A獂\PWMo͂
	EPwm1Regs.HRCNFG.bit.AUTOCONV = 1;	//ϊ@\L({IɗLݒ)
	EPwm1Regs.HRCNFG.bit.HRLOAD = 0;	//VhEWX^ANeBuWX^TBCTR=0Ń[h
	EPwm1Regs.HRCNFG.bit.CTLMODE = 1;	//ʑ
	EPwm1Regs.HRCNFG.bit.EDGMODE = 1;	//GbWE[h

	//ET Module Configuration
	//EPWMADC̃gK܂
	EPwm1Regs.ETSEL.bit.SOCAEN = 1;		//ADC ϊJnAiEPWMxSOCAjpX̃Cl[u
	EPwm1Regs.ETSEL.bit.SOCASEL = 1;	//ǂ̃^C~OŕϊJnApXo TBCTR[NA
	EPwm1Regs.ETPS.bit.SOCAPRD = 1;
	EPwm1Regs.ETCLR.bit.SOCA = 0;

	//^C}[X^[g
	SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 1;
	EDIS;
}

//*****************************************************************************
// \PWM̃Lu[V
// 莞ԊԊuŕKsB
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void HiPwmCalProcess(void){
	if(Timer.PwmCalCnt >= HiPwmCalInterval){
		Timer.PwmCalCnt = Reset;
		SFO();//PWMLu[V1bƂɎs
	}
}

//*****************************************************************************
// ADC֌W̏
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void InitADC2(void){
	EALLOW;
	PieVectTable.ADCINT1 = Cla1TaskIsr1;
	EDIS;

	InitAdc();
	EALLOW;
	//ADCRg[WX^ݒ
	AdcRegs.ADCCTL1.bit.INTPULSEPOS = 0;	//ADC荞݂

	//ADC荞݃tOƊ荞݃I[o[t[tÕNA
	AdcRegs.ADCINTFLGCLR.all = 0x1FF;		//ADC Int flag
	AdcRegs.ADCINTOVFCLR.all = 0x1FF;		//ADC Int ovfl clear

	//ADCINT1̐ݒ
	AdcRegs.INTSEL1N2.bit.INT1CONT = 1;		//ADC荞݃NGXg𖈉o
	AdcRegs.INTSEL1N2.bit.INT1E = 1;		//ADCINT1荞݂̋
	AdcRegs.INTSEL1N2.bit.INT1SEL = 4;		//SOC3ϊIADCINT1荞ݔ

	//SOC̃vCIeB̐ݒ
	AdcRegs.SOCPRICTL.bit.ONESHOT = 0; 		// One shot[h
	AdcRegs.SOCPRICTL.bit.SOCPRIORITY = 0; 	// S`lRound Robin[h
	//AdcRegs.SOCPRICTL.bit.SOCPRIORITY = 16; // S`lHigh Priority[h

	//TvO[h̐ݒ
	AdcRegs.ADCSAMPLEMODE.bit.SIMULEN0 = 0; // CH2 Single conversion mode
	AdcRegs.ADCSAMPLEMODE.bit.SIMULEN2 = 0; // CH1 Single conversion mode
	AdcRegs.ADCSAMPLEMODE.bit.SIMULEN4 = 0; // CH0 Single conversion mode

	//ADCINTSOCSEL configuration
	AdcRegs.ADCINTSOCSEL1.bit.SOC0 = 0; // ADCINT1ɂăgK֎~AADCSOCxCTLWX^TRIGSELŃgK܂B
	AdcRegs.ADCINTSOCSEL1.bit.SOC1 = 0; // ADCINT1ɂăgK֎~AADCSOCxCTLWX^TRIGSELŃgK܂B
	AdcRegs.ADCINTSOCSEL1.bit.SOC2 = 0; // ADCINT1ɂăgK֎~AADCSOCxCTLWX^TRIGSELŃgK܂B
	AdcRegs.ADCINTSOCSEL1.bit.SOC3 = 0; // ADCINT1ɂăgK֎~AADCSOCxCTLWX^TRIGSELŃgK܂B
	AdcRegs.ADCINTSOCSEL1.bit.SOC4 = 0; // ADCINT1ɂăgK֎~AADCSOCxCTLWX^TRIGSELŃgK܂B

	//SOC overflow clear
	AdcRegs.ADCSOCOVFCLR1.all = 0xFFFF;

	//SOC0 configuration(dummy : See Initial Conversion Errata)
	//SOC0ɂ͕s(gKڂ̒lȂ\)
	AdcRegs.ADCSOC0CTL.bit.TRIGSEL = 0x05;	// ePWM1 trigger
	AdcRegs.ADCSOC0CTL.bit.CHSEL = 0; 		// ADCINA0
	AdcRegs.ADCSOC0CTL.bit.ACQPS = 6; 		// Tvz[h 6+1TCN

	//SOC1 Configuration
	AdcRegs.ADCSOC1CTL.bit.TRIGSEL = 0x05; 	// ePWM1 trigger
	AdcRegs.ADCSOC1CTL.bit.CHSEL = 0;		// ADCINA1
	AdcRegs.ADCSOC1CTL.bit.ACQPS = 12; 		// Sample window = 13

	//SOC2 Configuration
	AdcRegs.ADCSOC2CTL.bit.TRIGSEL = 0x05; 	// ePWM1 trigger
	AdcRegs.ADCSOC2CTL.bit.CHSEL = 1; 		// ADCINA2
	AdcRegs.ADCSOC2CTL.bit.ACQPS = 12; 		// Sample window = 13

	//SOC3 Configuration
	AdcRegs.ADCSOC3CTL.bit.TRIGSEL = 0x05; 	// ePWM1 trigger
	AdcRegs.ADCSOC3CTL.bit.CHSEL = 2; 		// ADCINA3
	AdcRegs.ADCSOC3CTL.bit.ACQPS = 12; 		// Sample window = 13

	//SOC4 Configuration
	AdcRegs.ADCSOC4CTL.bit.TRIGSEL = 0x05; 	// ePWM1 trigger
	AdcRegs.ADCSOC4CTL.bit.CHSEL = 3; 		// ADCINA3
	AdcRegs.ADCSOC4CTL.bit.ACQPS = 12; 		// Sample window = 13

	//荞݋rbg̐ݒ
	PieCtrlRegs.PIEIER1.bit.INTx1 = 1;
	IER |= M_INT1;

	EDIS;
}

//*****************************************************************************
// CLȀ
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void InitCLA(void){
	EALLOW;
	PieVectTable.CLA1_INT1 = Cla1TaskIsr1;
	PieVectTable.CLA1_INT2 = Cla1TaskIsr2;
	PieVectTable.CLA1_INT3 = Cla1TaskIsr3;
	PieVectTable.CLA1_INT4 = Cla1TaskIsr4;
	PieVectTable.CLA1_INT5 = Cla1TaskIsr5;
	PieVectTable.CLA1_INT6 = Cla1TaskIsr6;
	PieVectTable.CLA1_INT7 = Cla1TaskIsr7;
	PieVectTable.CLA1_INT8 = Cla1TaskIsr8;
	EDIS;

	memcpy(&Cla1funcsRunStart, &Cla1funcsLoadStart, (Uint32)&Cla1funcsLoadSize);
	EALLOW;
	//Cla1Regs.MVECT1 = ((Uint16)Cla1Task1 - (Uint16)&Cla1Prog_Start);//
	Cla1Regs.MVECT1 = ((Uint16)Cla1Task1 - (Uint16)&Cla1Prog_Start);
	Cla1Regs.MVECT2 = ((Uint16)Cla1Task2 - (Uint16)&Cla1Prog_Start);
	Cla1Regs.MVECT3 = ((Uint16)Cla1Task3 - (Uint16)&Cla1Prog_Start);
	Cla1Regs.MVECT4 = ((Uint16)Cla1Task4 - (Uint16)&Cla1Prog_Start);
	Cla1Regs.MVECT5 = ((Uint16)Cla1Task5 - (Uint16)&Cla1Prog_Start);
	Cla1Regs.MVECT6 = ((Uint16)Cla1Task6 - (Uint16)&Cla1Prog_Start);
	Cla1Regs.MVECT7 = ((Uint16)Cla1Task7 - (Uint16)&Cla1Prog_Start);
	Cla1Regs.MVECT8 = ((Uint16)Cla1Task8 - (Uint16)&Cla1Prog_Start);

	Cla1Regs.MPISRCSEL1.bit.PERINT1SEL = CLA_INT1_ADCINT1;//CLA_INT1_NONE
	Cla1Regs.MPISRCSEL1.bit.PERINT2SEL = CLA_INT2_NONE;
	Cla1Regs.MPISRCSEL1.bit.PERINT3SEL = CLA_INT3_NONE;
	Cla1Regs.MPISRCSEL1.bit.PERINT4SEL = CLA_INT4_NONE;
	Cla1Regs.MPISRCSEL1.bit.PERINT5SEL = CLA_INT5_NONE;
	Cla1Regs.MPISRCSEL1.bit.PERINT6SEL = CLA_INT6_NONE;
	Cla1Regs.MPISRCSEL1.bit.PERINT7SEL = CLA_INT7_NONE;
	Cla1Regs.MPISRCSEL1.bit.PERINT8SEL = CLA_INT8_NONE;

	Cla1Regs.MIER.all = 0xffff;
	Cla1Regs.MCTL.bit.IACKE = 1;
	Cla1Regs.MMEMCFG.bit.PROGE = 1;
	Cla1Regs.MMEMCFG.bit.RAM0E = 1;
	Cla1Regs.MMEMCFG.bit.RAM1E = 1;
	EDIS;
	PieCtrlRegs.PIEIER11.bit.INTx1 = 1;
	IER |= M_INT11;

	//CLAϐ
	Cla1ForceTask8andWait();
}

//*****************************************************************************
// CLA荞݃^XN1
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr1(void){
	AdcRegs.ADCINTFLGCLR.all = 1;
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// CLA荞݃^XN2
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr2(void){
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// CLA荞݃^XN3
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr3(void){
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// CLA荞݃^XN4
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr4(void){
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// CLA荞݃^XN5
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr5(void){
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// CLA荞݃^XN6
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr6(void){
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// CLA荞݃^XN7
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr7(void){
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// CLA荞݃^XN8
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void Cla1TaskIsr8(void){
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP11;
}

//*****************************************************************************
// XCb`Od̏o͓dݒ肷
//*****************************************************************************
void SwVoltageSet (float SwVoltage,float SwCurrent){
	SwOUT(ON);	//XCb`OdNB
	CPUtoCLARAM.VSet = (fabs(SwVoltage))/((3.3/4095.0)*10.0);	//o͓dCLA֓n
	CPUtoCLARAM.ASet = (fabs(SwCurrent))/(8.25/4095);			//o͓dCLA֓n
}

//*****************************************************************************
// XCb`Od̏o͓dmF
//*****************************************************************************
float QSwVoltageSet(void){
	return CPUtoCLARAM.VSet;
}

//*****************************************************************************
// XCb`OdONOFF
//*****************************************************************************
void SwOUT(unsigned char On){
	CPUtoCLARAM.OOU_FLAG = On;
}

//*****************************************************************************
// CLAxp
//*****************************************************************************
void InitEPwm6(void){
	EALLOW;

	//Stop PWM Timer PWMWX^ݒ莞NbNK~
	SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 0;

	// Setup TBCLK
	EPwm6Regs.TBCTL.bit.PRDLD = TB_IMMEDIATE;	//ݒll𑦔f
	EPwm6Regs.TBPRD = 0xffff;					//PWM̐ݒ
	EPwm6Regs.TBPHS.all = 0;					//ʑ̐ݒ
	EPwm6Regs.TBCTR = 0;						//JE^l̃NA
	EPwm6Regs.TBCTL.bit.CTRMODE = TB_COUNT_UP;	//^C}JEgAbv
	EPwm6Regs.TBCTL.bit.PHSEN = TB_DISABLE;		//^C}Ȃ(EPwm1Ƃđ̃^C}𓯊邽)
	EPwm6Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO;	//used to sync EPWM(n+1) "down-stream"
	EPwm6Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;
	EPwm6Regs.TBCTL.bit.CLKDIV = TB_DIV1;

	//^C}[X^[g
	SysCtrlRegs.PCLKCR0.bit.TBCLKSYNC = 1;

	EDIS;
}

//*****************************************************************************
// I
//*****************************************************************************
