//*****************************************************************************
// t@C      MainCVCC.c
// Ώۃ}CR    TI C2000
// t@Ce    CVCCdu\tg
//             yoshikiyo
//*****************************************************************************
//=============================================================================
//include
//=============================================================================
#include    "DSP28x_Project.h"
#include    "SFO_V6.h"
#include    "MainCVCC.h"
#include    "c.h"
#include    "DigitalPower.h"
#include    "spi.h"
#include    "SevenSeg.h"
#include    "beep.h"

//IQmathLib
#define     GLOBAL_Q 22 // range = +-512
#include    "IQmathLib.h"

//W֐
#include    <string.h>
#include    <stdint.h>
#include    <stdio.h>
#include    <stdlib.h>

//=============================================================================
// Functions that will be run from RAM need to be assigned to
// a different section.  This section will then be mapped using
// the linker cmd file.
//=============================================================================
#pragma CODE_SECTION(CpuTimer0ISR, "ramfuncs");

//=============================================================================
//vg^Cv錾
//=============================================================================
//======================================
//General
//======================================
void InitPowCpu(void);
void InitCPU(void);
void InitIO(void);
void InitCpuTimer0(void);
void WatchdogEnabl(void);
void WatchdogClear(void);

//======================================
//interrupt
//======================================
__interrupt void CpuTimer0ISR(void);

//=============================================================================
//O[oϐ̐錾
//=============================================================================
//tOA^C}p\̂̐錾Ə
TIMER Timer = {0,0,0};

unsigned long long MeasV_Sum,MeasA_Sum,SetV_Sum,SetA_Sum;

//======================================
//General
//======================================
extern Uint16 RamfuncsLoadStart;
extern Uint16 RamfuncsLoadSize;
extern Uint16 RamfuncsRunStart;

//*****************************************************************************
// main
//*****************************************************************************
void main(void)
{
    //======================================
    //eytF̏
    //======================================
    //CPU@\̏
    InitPowCpu();

    //ꉞWX^یLɂ
    EDIS;

    //uU[
    setBeepPattern( 0xa );

    //\
    SegOut(999,999);
    Delay(1000);

    //ϐ
    MeasV_Sum = 0;
    MeasA_Sum = 0;
    SetV_Sum = 0;
    SetA_Sum = 0;

    //======================================
    //C[v
    //======================================
    while(1){
        //======================================
        //\PWMLu[V
        //======================================
        HiPwmCalProcess();

        //======================================
        //fW^d
        //======================================
        DigitalPowerProcess();
    }
}

//*****************************************************************************
// CpuTimer0荞ݏ 1msƂɊ荞݂܂
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
__interrupt void CpuTimer0ISR(void){
    beepProcess();      //uU[֐
    SevenSegProcess();  //7ZO֐

    //e^C}pJE^̃CNg
    Timer.PwmCalCnt++;
    Timer.DelayCnt++;
    Timer.LCDCnt++;

    if(Timer.LCDCnt <= 300){
        MeasV_Sum += AdcResult.ADCRESULT4;
        MeasA_Sum += AdcResult.ADCRESULT3;
    }

    //^C}荞݃tONA
    PieCtrlRegs.PIEACK.all = PIEACK_GROUP1;
}

//*****************************************************************************
// PowerCpȕ
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void InitPowCpu(void){
    InitCPU();          //CPU

    //FlashRAMփRs[ CPȔɎs邱
    memcpy(&RamfuncsRunStart,&RamfuncsLoadStart, (unsigned long)&RamfuncsLoadSize);

    InitFlash();        //Flash̏

    //eytF̏
    InitCpuTimer0();    //^C}荞ݏ
    InitIO();           //IO|[g̏
    InitSPIA();         //SPIA
    InitDigitalPower(); //fW^d̏
    initBeep();         //uU[
    InitSevenSeg();     //7ZO\
}

//*****************************************************************************
// CPUAytF̏
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void InitCPU(void){

    //VXeNbN̏
    //ftHg͓̔UgpĂ
    //L֐Œ`Ă̂ŕKvɂĕύX
    InitSysCtrl();

    //LSPCLKݒ SCI,SPINbN
    EALLOW;
    SysCtrlRegs.LOSPCP.bit.LSPCLK = 0;  //LSPCLK = SYSCLKOUT(60MHz)
    EDIS;

    //荞ݏ֌W̏
    DINT;               //S̊荞݂̕s
    InitPieCtrl();      //PEȈ
    IER = 0x0000;       //荞݋WX^(IER)̃NA
    IFR = 0x0000;       //荞݃tOWX^(IFR)̃NA
    InitPieVectTable(); //PIExN^Ee[ułɃ_~[̊荞݊֐ǉ
    EINT;               //O[o荞݂̋
}

//*****************************************************************************
// |[g̏
//  Ȃ
// ߂l Ȃ
//
// IO|[gݒ GPAMUX̐ݒ ftHgIO|[gݒ
// eytF̏ݒ֐̒łgp|[gMUXݒ͍sĂ邪
// SĖmɂ邽߂ɂłׂĂIO|[g̐ݒs
// gpsGPIOݒ  CPUvAbvON
//*****************************************************************************
void InitIO(void){
    EALLOW;

    //======================================
    //IO|[gݒ GPAMUX̐ݒ ftHgIO|[gݒ
    //======================================
    GpioCtrlRegs.GPAMUX1.bit.GPIO0  = 1;    //EPWM1A
    GpioCtrlRegs.GPAMUX1.bit.GPIO1  = 1;    //EPWM1B
    GpioCtrlRegs.GPAMUX1.bit.GPIO2  = 1;    //EPWM2A
    GpioCtrlRegs.GPAMUX1.bit.GPIO3  = 1;    //EPWM2B
    GpioCtrlRegs.GPAMUX1.bit.GPIO4  = 1;    //EPWM2A
    GpioCtrlRegs.GPAMUX1.bit.GPIO5  = 1;    //EPWM3B
    GpioCtrlRegs.GPAMUX1.bit.GPIO6  = 0;    //EPWM4A
    GpioCtrlRegs.GPAMUX1.bit.GPIO7  = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO8  = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO9  = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO10 = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO11 = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO12 = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO13 = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO14 = 0;    //gp
    GpioCtrlRegs.GPAMUX1.bit.GPIO15 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO16 = 1;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO17 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO18 = 1;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO19 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO20 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO21 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO22 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO23 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO24 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO25 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO26 = 0;    //gp
    GpioCtrlRegs.GPAMUX2.bit.GPIO27 = 0;    //tJ[LEDR
    //GpioCtrlRegs.GPAMUX2.bit.GPIO28 = 0;  //SCIRXDA
    //GpioCtrlRegs.GPAMUX2.bit.GPIO29 = 0;  //SCITXDA
    GpioCtrlRegs.GPAMUX2.bit.GPIO30 = 0;    //tJ[LEDB
    GpioCtrlRegs.GPAMUX2.bit.GPIO31 = 0;    //tJ[LEDG
    GpioCtrlRegs.GPBMUX1.bit.GPIO32 = 0;    //gp
    GpioCtrlRegs.GPBMUX1.bit.GPIO33 = 0;    //gp
    //---------------------------------------------------------
    //JTAGABOOT[hIs
    GpioCtrlRegs.GPBMUX1.bit.GPIO34 = 0;    //BOOT[hI gpł͂Ȃgp|[gs
    //GpioCtrlRegs.GPBMUX1.bit.GPIO35 = 0;  //JTAG TDI ݒ֎~
    //GpioCtrlRegs.GPBMUX1.bit.GPIO36 = 0;  //JTAG TMS ݒ֎~
    //GpioCtrlRegs.GPBMUX1.bit.GPIO37 = 0;  //JTAG TDO ݒ֎~ BOOT[hI
    //GpioCtrlRegs.GPBMUX1.bit.GPIO38 = 0;  //JTAG TCK ݒ֎~
    //---------------------------------------------------------
    GpioCtrlRegs.GPBMUX1.bit.GPIO39 = 0;    //gp
    GpioCtrlRegs.GPBMUX1.bit.GPIO40 = 0;    //gp
    GpioCtrlRegs.GPBMUX1.bit.GPIO41 = 0;    //gp
    GpioCtrlRegs.GPBMUX1.bit.GPIO42 = 0;    //gp
    GpioCtrlRegs.GPBMUX1.bit.GPIO43 = 0;    //gp
    GpioCtrlRegs.GPBMUX1.bit.GPIO44 = 0;    //gp

    //======================================
    //IO|[gݒ
    //======================================
    //GpioCtrlRegs.GPADIR.bit.GPIO0     = OUT;  //EPWM1A
    //GpioCtrlRegs.GPADIR.bit.GPIO1     = OUT;  //EPWM1B
    GpioCtrlRegs.GPADIR.bit.GPIO2   = OUT;  //EPWM2A
    GpioCtrlRegs.GPADIR.bit.GPIO3   = OUT;  //EPWM2B
    GpioCtrlRegs.GPADIR.bit.GPIO4   = OUT;  //EPWM3A
    GpioCtrlRegs.GPADIR.bit.GPIO5   = OUT;  //EPWM3B
    GpioCtrlRegs.GPADIR.bit.GPIO6   = OUT;  //EPWM4A
    GpioCtrlRegs.GPADIR.bit.GPIO7   = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO8   = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO9   = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO10  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO11  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO12  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO13  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO14  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO15  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO16  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO17  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO18  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO19  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO20  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO21  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO22  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO23  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO24  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO25  = IN;   //gp
    GpioCtrlRegs.GPADIR.bit.GPIO26  = OUT;  //gp
    GpioCtrlRegs.GPADIR.bit.GPIO27  = OUT;  //tJ[LEDR
    //GpioCtrlRegs.GPADIR.bit.GPIO28    = IN;   //SCIRXDA
    //GpioCtrlRegs.GPADIR.bit.GPIO29    = IN;   //SCITXDA
    GpioCtrlRegs.GPADIR.bit.GPIO30  = OUT;  //tJ[LEDG
    GpioCtrlRegs.GPADIR.bit.GPIO31  = OUT;  //tJ[LEDB
    GpioCtrlRegs.GPBDIR.bit.GPIO32  = OUT;  //gp
    GpioCtrlRegs.GPBDIR.bit.GPIO33  = OUT;  //gp
    //---------------------------------------------------------
    //JTAGABOOT[hIs
    GpioCtrlRegs.GPBDIR.bit.GPIO34  = OUT;      //BOOT[hI gpł͂Ȃgp|[gs
    //GpioCtrlRegs.GPBDIR.bit.GPIO35    = IN;   //JTAG TDI ݒ֎~
    //GpioCtrlRegs.GPBDIR.bit.GPIO36    = IN;   //JTAG TMS ݒ֎~
    //GpioCtrlRegs.GPBDIR.bit.GPIO37    = IN;   //JTAG TDO ݒ֎~ BOOT[hI
    //GpioCtrlRegs.GPBDIR.bit.GPIO38    = IN;   //JTAG TCK ݒ֎~
    //---------------------------------------------------------
    GpioCtrlRegs.GPBDIR.bit.GPIO39  = OUT;      //gp
    GpioCtrlRegs.GPBDIR.bit.GPIO40  = OUT;      //gp
    GpioCtrlRegs.GPBDIR.bit.GPIO41  = OUT;      //gp
    GpioCtrlRegs.GPBDIR.bit.GPIO42  = OUT;      //gp
    GpioCtrlRegs.GPBDIR.bit.GPIO43  = OUT;      //gp
    GpioCtrlRegs.GPBDIR.bit.GPIO44  = OUT;      //gp

    EDIS;
}

//*****************************************************************************
// CpuTimer0̏
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void InitCpuTimer0(void){
    EALLOW;
    PieVectTable.TINT0 = CpuTimer0ISR;      //xN^e[uTINT0荞݂ǉ
    EDIS;

    //CpuTimer0̐ݒ
    InitCpuTimers();
    //(^C}ԍւstructϐAhX ,CPUNbNg(MHz) ,^C}(usec) )
    ConfigCpuTimer(&CpuTimer0, 60, 1000);   //1ms̊荞

    //荞݋rbg̐ݒ
    IER |= M_INT1;
    PieCtrlRegs.PIEIER1.bit.INTx7 = 1;

    CpuTimer0Regs.TCR.all = 0x4000;         //CpuTimer0JEgX^[g
}

//*****************************************************************************
// EHb`hbN^C}X^[g
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void WatchdogEnabl(void){
    EALLOW;
    SysCtrlRegs.WDCR= 0x0028;
    EDIS;
}

//*****************************************************************************
// EHb`hbN^C}莞ԊԊuŃNAB
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void WatchdogClear(void){

}

//*****************************************************************************
// ^C}{
//  ҂ timer_set[ms]
// ߂l Ȃ
//*****************************************************************************
void Delay( unsigned long timer_set ){
    Timer.DelayCnt = 0;
    while( Timer.DelayCnt < timer_set );
}

//*****************************************************************************
// tJ[LED
//  Ȃ
// ߂l Ȃ
//*****************************************************************************
void FullColorLed_Out( unsigned char led ){
    switch ( led ){
        case WHITE:
            GpioDataRegs.GPASET.bit.GPIO27      = 1;
            GpioDataRegs.GPASET.bit.GPIO30      = 1;
            GpioDataRegs.GPASET.bit.GPIO31      = 1;
        break;
        case BLUE:
            GpioDataRegs.GPACLEAR.bit.GPIO27    = 1;
            GpioDataRegs.GPASET.bit.GPIO30      = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO31    = 1;
        break;
        case RED:
            GpioDataRegs.GPASET.bit.GPIO27      = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO30    = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO31    = 1;
        break;
        case GREEN:
            GpioDataRegs.GPACLEAR.bit.GPIO27    = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO30    = 1;
            GpioDataRegs.GPASET.bit.GPIO31      = 1;
        break;
        case YELLOW:
            GpioDataRegs.GPASET.bit.GPIO27      = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO30    = 1;
            GpioDataRegs.GPASET.bit.GPIO31      = 1;
        break;
        case CYAN:
            GpioDataRegs.GPACLEAR.bit.GPIO27    = 1;
            GpioDataRegs.GPASET.bit.GPIO30      = 1;
            GpioDataRegs.GPASET.bit.GPIO31      = 1;
        break;
        case MAGENTA:
            GpioDataRegs.GPASET.bit.GPIO27      = 1;
            GpioDataRegs.GPASET.bit.GPIO30      = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO31    = 1;
        break;
        case BLACK:
            GpioDataRegs.GPACLEAR.bit.GPIO27    = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO30    = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO31    = 1;
        break;
        default:
            GpioDataRegs.GPACLEAR.bit.GPIO27    = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO30    = 1;
            GpioDataRegs.GPACLEAR.bit.GPIO31    = 1;
        break;
    }
}

//*****************************************************************************
// I
//*****************************************************************************
