//*****************************************************************************
// Ώۃ}CR 		C2000 Piccolo F28055
// ̧ٓe		Linker Command File For 28055 CLA Cexamples
// 			yoshikiyo
// l			TĨTvR[ĥłB
//*****************************************************************************

//=============================================================================
// For Code Composer Studio V2.2 and later
// ---------------------------------------
// In addition to this memory linker command file,
// add the header linker command file directly to the project.
// The header linker command file is required to link the
// peripheral structures to the proper locations within
// the memory map.
//
// The header linker files are found in <base>\DSP2803x_Headers\cmd
//
// For BIOS applications add:      DSP2803x_Headers_BIOS.cmd
// For nonBIOS applications add:   DSP2803x_Headers_nonBIOS.cmd
//=============================================================================

//=============================================================================
// For Code Composer Studio prior to V2.2
// --------------------------------------
// 1) Use one of the following -l statements to include the
// header linker command file in the project. The header linker
// file is required to link the peripheral structures to the proper
// locations within the memory map                                    */

/* Uncomment this line to include file only for non-BIOS applications */
/* -l DSP2803x_Headers_nonBIOS.cmd */

/* Uncomment this line to include file only for BIOS applications */
/* -l DSP2803x_Headers_BIOS.cmd */

/* 2) In your project add the path to <base>\DSP2803x_headers\cmd to the
   library search path under project->build options, linker tab,
   library search path (-i).
//=============================================================================

//*****************************************************************************
// CLA@scratchpad area̒`
//*****************************************************************************
/* Define the memory block start/length for the F28035
   PAGE 0 will be used to organize program sections
   PAGE 1 will be used to organize data sections

   Notes:
         Memory blocks on F2803x are uniform (ie same
         physical memory) in both PAGE 0 and PAGE 1.
         That is the same memory region should not be
         defined for both PAGE 0 and PAGE 1.
         Doing so will result in corruption of program
         and/or data.

         L0 memory block is mirrored - that is
         it can be accessed in high memory or low memory.
         For simplicity only one instance is used in this
         linker file.

         Contiguous SARAM memory blocks or flash sectors can be
         be combined if required to create a larger memory block.
*/
CLA_SCRATCHPAD_SIZE=0x100;
_Cla1Prog_Start = _Cla1funcsRunStart;
-heap	0x200
-stack	0x200

// Define a size for the CLA scratchpad area that will be used
// by the CLA compiler for local symbols and temps
// Also force references to the special symbols that mark the
// scratchpad are. 
// CLA_SCRATCHPAD_SIZE = 0x100;
--undef_sym=__cla_scratchpad_end
--undef_sym=__cla_scratchpad_start

//*****************************************************************************
// ubÑX^[gʒuƃTCY̒`
//*****************************************************************************
MEMORY
{
	//======================================
	// Program Memory
	//======================================
	PAGE 0:	/* Program Memory */
           	/* Memory (RAM/FLASH/OTP) blocks can be moved to PAGE1 for data allocation */
	   RAML0       : origin = 0x008000, length = 0x000800     /* on-chip RAM block L0 */
	   RAML3       : origin = 0x009000, length = 0x001000     /* on-chip RAM block L3 */
	   OTP         : origin = 0x3D7800, length = 0x000400     /* on-chip OTP */
	   FLASHH      : origin = 0x3E8000, length = 0x002000     /* on-chip FLASH */
	   FLASHG      : origin = 0x3EA000, length = 0x002000     /* on-chip FLASG */
	   FLASHF      : origin = 0x3EC000, length = 0x002000     /* on-chip FLASF */
	   FLASHE      : origin = 0x3EE000, length = 0x002000     /* on-chip FLASE */
	   FLASHD      : origin = 0x3F0000, length = 0x002000     /* on-chip FLASD */
	   FLASHC      : origin = 0x3F2000, length = 0x002000     /* on-chip FLASC */
	   FLASHB      : origin = 0x3F4000, length = 0x002000     /* on-chip FLASB */
	   FLASHA      : origin = 0x3F6000, length = 0x001F80     /* on-chip FLASA */
	   CSM_RSVD    : origin = 0x3F7F80, length = 0x000076     /* Part of FLASHA.  Program with all 0x0000 when CSM is in use. */
	   BEGIN       : origin = 0x3F7FF6, length = 0x000002     /* Part of FLASHA.  Used for "boot to Flash" bootloader mode. */
	   CSM_PWL_P0  : origin = 0x3F7FF8, length = 0x000008     /* Part of FLASHA.  CSM password locations in FLASHA */

	   IQTABLES    : origin = 0x3FE000, length = 0x000B50     /* IQ Math Tables in Boot ROM */
	   IQTABLES2   : origin = 0x3FEB50, length = 0x00008C     /* IQ Math Tables in Boot ROM */
	   IQTABLES3   : origin = 0x3FEBDC, length = 0x0000AA	  /* IQ Math Tables in Boot ROM */

	   ROM         : origin = 0x3FF27C, length = 0x000D44     /* Boot ROM */
	   RESET       : origin = 0x3FFFC0, length = 0x000002     /* part of boot ROM  */
	   VECTORS     : origin = 0x3FFFC2, length = 0x00003E     /* part of boot ROM  */

	//======================================
	// Data Memory
	//======================================
	PAGE 1 :	/* Data Memory */
           		/* Memory (RAM/FLASH/OTP) blocks can be moved to PAGE0 for program allocation */
           		/* Registers remain on PAGE1                                                  */
	   BOOT_RSVD   : origin = 0x000000, length = 0x000050     /* Part of M0, BOOT rom will use this for stack */
	   RAMM1       : origin = 0x000400, length = 0x000400     /* on-chip RAM block M1 */
	   RAMM0       : origin = 0x000050, length = 0x0003B0     /* on-chip RAM block M0 */

	   CLARAM0     : origin = 0x008800, length = 0x000400
	   CLARAM1     : origin = 0x008C00, length = 0x000400

	   CLA1_MSGRAMLOW   : origin = 0x001480, length = 0x000080
	   CLA1_MSGRAMHIGH  : origin = 0x001500, length = 0x000080
}

/* Allocate sections to memory blocks.
   Note:
         codestart user defined section in DSP28_CodeStartBranch.asm used to redirect code
                   execution when booting to flash
         ramfuncs  user defined section to store functions that will be copied from Flash into RAM
*/

//*****************************************************************************
// ubNɃZNV蓖Ă
//*****************************************************************************
SECTIONS
{

	//======================================
	// Allocate program areas:
	//======================================
	.cinit              : > FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH	PAGE = 0
	.pinit              : > FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH,	PAGE = 0
	.text               : >> FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH	PAGE = 0
	codestart           : > BEGIN       PAGE = 0
	ramfuncs            : LOAD = FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH,
                          RUN = RAML0,
                          LOAD_START(_RamfuncsLoadStart),
                          LOAD_SIZE(_RamfuncsLoadSize),
                          RUN_START(_RamfuncsRunStart),
                          PAGE = 0

	csmpasswds          : > CSM_PWL_P0  PAGE = 0
	csm_rsvd            : > CSM_RSVD    PAGE = 0

	//======================================
	// Allocate uninitalized data sections:
	//======================================
	.stack              : > RAMM0	PAGE = 1
	.cio                : > RAMM0	PAGE = 1
	.sysmem             : > RAMM0	PAGE = 1	//̃ZNV͐邪gp
	.ebss               : > RAMM1	PAGE = 1
	.esysmem            : > RAMM1	PAGE = 1

	//======================================
	// Initalized sections go in Flash
    // For SDFlash to program these, they must be allocated to page 0
	//======================================
	.econst             : > FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH      PAGE = 0
	.switch             : > FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH      PAGE = 0
   
	//======================================
	// Allocate IQ math areas:
	//======================================
	IQmath              : > FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH      PAGE = 0            /* Math Code */
	IQmathTables        : > IQTABLES,   PAGE = 0, TYPE = NOLOAD
   
	//======================================
	// CLA֌W̃ZNV`
	//======================================
	.bss_cla		       : > CLARAM0,   PAGE = 1

	Cla1Prog            : LOAD = FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH,
                          RUN = RAML3,
                          LOAD_START(_Cla1funcsLoadStart),
                          LOAD_END(_Cla1funcsLoadEnd),
                          RUN_START(_Cla1funcsRunStart),
                          LOAD_SIZE(_Cla1funcsLoadSize),
                          PAGE = 0

	Cla1ToCpuMsgRAM     : > CLA1_MSGRAMLOW,   PAGE = 1
	CpuToCla1MsgRAM     : > CLA1_MSGRAMHIGH,  PAGE = 1
	Cla1DataRam0		: > CLARAM0,		  PAGE = 1
	Cla1DataRam1		: > CLARAM1,		  PAGE = 1

	.const_cla	        : LOAD = FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH,
                          RUN = CLARAM0,
                          LOAD_START(_Cla1ConstLoadStart),
                          LOAD_END(_Cla1ConstLoadEnd),
                          RUN_START(_Cla1ConstRunStart),
                          LOAD_SIZE(_Cla1ConstLoadSize),
                          PAGE = 1

	CLA1mathTables	    : LOAD = FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH,
                          RUN = CLARAM0,
                          LOAD_START(_Cla1mathTablesLoadStart),
                          LOAD_END(_Cla1mathTablesLoadEnd),
                          RUN_START(_Cla1mathTablesRunStart),
                          LOAD_SIZE(_Cla1mathTablesLoadSize),
                          PAGE = 1

   /*
	GROUP	            : LOAD = FLASHB|FLASHC|FLASHD|FLASHE|FLASHF|FLASHG|FLASHH,
                          RUN = CLARAM0,
                          LOAD_START(_Cla1mathTablesLoadStart),
                          LOAD_END(_Cla1mathTablesLoadEnd),
                          RUN_START(_Cla1mathTablesRunStart),
                          LOAD_SIZE(_Cla1mathTablesLoadSize),
                          PAGE = 1
	{
		CLA1mathTables
		.const_cla
	}
	*/
	
	CLAscratch          :
                         {
                         *.obj(CLAscratch)
                       	 . += CLA_SCRATCHPAD_SIZE;
                         *.obj(CLAscratch_end)
                         }
                         > CLARAM0,
					     PAGE = 1

					 
	/* Uncomment the section below if calling the IQNexp() or IQexp()
      functions from the IQMath.lib library in order to utilize the
      relevant IQ Math table in Boot ROM (This saves space and Boot ROM
      is 1 wait-state). If this section is not uncommented, IQmathTables2
      will be loaded into other memory (SARAM, Flash, etc.) and will take
      up space, but 0 wait-state is possible.
	*/
	/*
	IQmathTables2    : > IQTABLES2, PAGE = 0, TYPE = NOLOAD
	{

		IQmath.lib<IQNexpTable.obj> (IQmathTablesRam)

	}
	*/
	/* Uncomment the section below if calling the IQNasin() or IQasin()
       functions from the IQMath.lib library in order to utilize the
       relevant IQ Math table in Boot ROM (This saves space and Boot ROM
       is 1 wait-state). If this section is not uncommented, IQmathTables2
       will be loaded into other memory (SARAM, Flash, etc.) and will take
       up space, but 0 wait-state is possible.
    */
    /*
    IQmathTables3    : > IQTABLES3, PAGE = 0, TYPE = NOLOAD
    {

               IQmath.lib<IQNasinTable.obj> (IQmathTablesRam)

    }
    */

	//======================================
	// RpCZNV RAMȂ̂łǂɂ蓖ĂȂ悤ɂ
	//======================================
	.reset              : > RESET,      PAGE = 0, TYPE = DSECT
	vectors             : > VECTORS     PAGE = 0, TYPE = DSECT
}

//*****************************************************************************
// End of file.
//*****************************************************************************
